"""
Python module containing object models for data used by the app editor API
"""


class FileSystemItem(object):
    """
    Base object model class for files & folders
    """
    def __init__(self, name=None, path=None):
        self.name = name
        self.path = path


class File(FileSystemItem):
    """
    Object model for a file on the local file system
    """
    def __init__(self, name=None, path=None, file_type=None):
        super(File, self).__init__(name=name, path=path)
        self.file_type = file_type


class Folder(File):
    """
    Object model for a folder on the local file system
    """
    def __init__(self, name=None, path=None, file_type=None):
        super(Folder, self).__init__(name=name, path=path, file_type=file_type)
        self.contents = []


class FileContents(object):
    """
    Object model to hold the contents of a file
    """
    def __init__(self, path=None, contents=None):
        self.path = path
        self.contents = contents


class OrderedResource(object):
    """
    Object model representing an ordered resource in the pip or RPM folder
    """
    def __init__(self, name=None, ordering=0):
        self.name = name
        self.ordering = ordering
