riot.tag2('editor-view', '<div id="editorViewWrapper" class="row-fluid main-pane"><div id="fileExplorerWrapper" class="col-sm-2 content-pane"><file-explorer name="fileExplorer"></file-explorer></div><div class="form-wrapper" id="fileFormWrapper"><new-file-form name="newFileFormTag"></new-file-form></div><div class="form-wrapper" id="folderFormWrapper"><new-folder-form name="newFolderFormTag"></new-folder-form></div><div class="form-wrapper" id="saveAsFormWrapper"><save-as-form name="saveAsFormTag"></save-as-form></div><confirm-yes-no-dialog name="confirm-yes-no-dialog"></confirm-yes-no-dialog><confirm-dialog name="confirm-dialog"></confirm-dialog><div class="col-sm-10 content-pane sp" id="editorWrapper"><div id="editorPanel" class="panel-body"><file-editor name="fileEditor"></file-editor></div></div></div>', '', '', function(opts) {

    var instance = this;

    this.fileEditor = this.tags.fileEditor;
    this.newFileForm = this.tags.newFileFormTag;
    this.newFolderForm = this.tags.newFolderFormTag;
    this.saveAsForm = this.tags.saveAsFormTag;
    this.fileExplorer = this.tags.fileExplorer;

    this.resetForms = function()
    {
        this.newFileForm.resetForm();
        this.newFolderForm.resetForm();
        this.saveAsForm.resetForm();
    }.bind(this)

    this.openFormWrapper = function( formWrapperId )
    {
      var explorerWrapperWidth = $( "#fileExplorerWrapper" ).css( "width" );
      $( formWrapperId ).css( 'margin-left', explorerWrapperWidth );
      $( formWrapperId ).addClass( "form-open" );
    }.bind(this)

    this.closeFormWrapper = function( formWrapperId )
    {
      if ( $( formWrapperId ).hasClass( "form-open" ) )
      {
          $( formWrapperId ).removeClass( "form-open" );
      }

      var explorerWrapperWidth = $( "#fileExplorerWrapper" ).width();
      $( formWrapperId ).css( 'margin-left', ( 0 - ( explorerWrapperWidth * 2 ) ) );
    }.bind(this)

    $( function ()
    {
      $( '#fileExplorerWrapper' ).resizable({ handles: "e", start: function( event, ui ) {
        var totalWidth = 0;
        $( '.editor-tabs' ).each(function(){
        totalWidth += $(this).outerWidth();
        });
        if ( totalWidth == 0 )
        {
          totalWidth = 400;
        }
        var max_width = Math.floor($( '#main_container' ).innerWidth() - (totalWidth + 100))
        $( '#fileExplorerWrapper' ).resizable('option', 'maxWidth', max_width );
      } });

      $( '#fileExplorerWrapper' ).on( "resize", function( event, ui )
      {

          $( '#editorWrapper' ).css('width', Math.floor($( '#main_container' ).innerWidth() -  $( "#fileExplorerWrapper" ).innerWidth()));
          instance.fileEditor.resizeEditorWindows();

          $( '.form-wrapper.form-open' ).each( function( index, data )
          {
            var formWrapperId = "#" + data.id;
            var explorerWrapperWidth = $( '#fileExplorerWrapper' ).css( 'width' );
            $( formWrapperId ).css( 'margin-left', explorerWrapperWidth );
          });
          event.stopPropagation();
      });
    });

    $(window).bind( 'resizeEnd', function()
    {
      $( '#fileExplorerWrapper' ).css( 'width', '250px' );
      $( '#editorWrapper' ).css( 'width', Math.floor($( '#main_container' ).innerWidth() -  $( '#fileExplorerWrapper' ).innerWidth()));
      instance.update();
    });

    $(window).resize(function() {
       if(this.resizeTO) clearTimeout(this.resizeTO);
       this.resizeTO = setTimeout(function() {
           $(this).trigger('resizeEnd');
       }, 300);
     });

});

riot.tag2('file-editor', '<ul if="{this.hasEditorWindows()}" class="nav nav-tabs" id="fileEditorTabNav"><li each="{editorWindow, i in editorWindows}" role="presentation" id="{editorWindow.tabId}" class="editor-tabs"><a href="{editorWindow.contentHref}" role="tab" data-toggle="tab">{editorWindow.tabName} <span class="tab-save"> * </span><span class="glyphicon glyphicon-refresh saving"></span><span class="tab-close" onclick="{checkWindowNeedsSaved.bind( this, editorWindow )}"> x </span></a></li></ul><div if="{this.hasEditorWindows()}" class="tab-content" id="fileEditorTabContent"><div each="{editorWindow, i in editorWindows}" class="tab-pane" id="{editorWindow.contentId}"><div class="editor-div" id="{editorWindow.editorId}"></div></div></div><div id="filelessDiv" if="{! this.hasEditorWindows()}"><h id="openFilePrompt" data-localize="editor.filePrompt">Double click a file in the explorer to begin editing its content</h></div>', '', '', function(opts) {

    this.editorWindows = [];
    this.aceTheme = "ace/theme/chrome";
    this.modeList = ace.require( "ace/ext/modelist" );

    this.hasEditorWindows = function(){
      return ( this.editorWindows.length > 0 );
    }.bind(this)

    this.getFilePathId = function( filePath )
    {
      var filePathId = filePath.replace( /[!"#$%&'()*+,.\/:;<=>?@[\\\]^`{|}~]/g, '_' );

      return filePathId;
    }.bind(this)

    this.getTabId = function( filePath )
    {
      var tabId = this.getFilePathId( filePath ) + '_tab';
      return tabId;
    }.bind(this)

    this.getEditorId = function( filePath )
    {
      var editorId = this.getFilePathId( filePath ) + '_editor';
      return editorId;
    }.bind(this)

    this.getEditorWindowByFilePath = function( filePath )
    {
      var tabId = this.getTabId( filePath )
      var editorWindow = null;

      $( this.editorWindows ).each( function( index, obj )
      {
        if ( tabId === obj.tabId )
        {
          editorWindow = obj;
          return false;
        }
      });

      return editorWindow;
    }.bind(this)

    this.getEditorWindowByActiveTab = function( )
    {
      var editorWindow = null;

      if ( this.hasEditorWindows() )
      {
        var tabId = $("ul#fileEditorTabNav li.active")[0].id;
        $( this.editorWindows ).each( function( index, obj )
        {
          if ( tabId === obj.tabId )
          {
            editorWindow = obj;
            return false;
          }
        });
      }
      return editorWindow;
    }.bind(this)

    this.resizeEditorWindows = function( )
    {
      $( this.editorWindows ).each( function( index, obj )
      {
        obj.editor.resize();
      });
    }.bind(this)

    this.pushNodeUpdate = function( nodeObj, editorWindow )
    {
      var filePath = nodeObj.id;
      var fileType = nodeObj.data.file_type;

      var filePathId = this.getFilePathId( filePath );
      var tabId = this.getTabId( filePath );
      var editorId = this.getEditorId( filePath );

      var tabName = nodeObj.text
      var contentId = filePathId
      var contentHref = "#" + contentId;

      editorWindow.tabId = tabId;
      editorWindow.tabName = tabName;
      editorWindow.contentHref = contentHref;
      editorWindow.contentId = contentId;
      editorWindow.editorId = editorId;

      var mode = this.modeList.getModeForPath( fileType ).mode;
      editorWindow.editor.getSession().setMode( mode );

      this.update();

      var aceEditor = ace.edit( editorId );
      aceEditor.filePath = filePath;

      addAceContentChangedListener( aceEditor, tabId );
      addSaveCmdListener( aceEditor, tabId );
    }.bind(this)

    this.hasWindow = function( tabId )
    {
      hasWindow = false;

      $( this.editorWindows ).each( function ( index, obj )
      {
        if ( tabId === obj.tabId )
        {
          hasWindow = true;
          return false;
        }
      });

      return hasWindow;
    }.bind(this)

    this.addEditorWindow = function( nodeObj, content )
    {
      var filePath = nodeObj.id;
      var fileType = nodeObj.data.file_type;

      var filePathId = this.getFilePathId( filePath );
      var tabId = this.getTabId( filePath );
      var editorId = this.getEditorId( filePath );

      var tabName = nodeObj.text
      var contentId = filePathId
      var contentHref = "#" + contentId;

      var editorWindow = {
        'tabId' : tabId,
        'tabName' : tabName,
        'contentHref' : contentHref,
        'contentId' : contentId,
        'editorId' : editorId
      }

      this.editorWindows.push( editorWindow );
      this.update();

      var aceEditor = ace.edit( editorId );
      editorWindow.editor = aceEditor;

      var mode = this.modeList.getModeForPath( fileType ).mode;

      aceEditor.setTheme( this.aceTheme );
      aceEditor.setOptions( { enableBasicAutocompletion: true } );

      if ( filePath.indexOf( 'manifest.json' ) != -1 )
      {
        try
        {
          var tmpJsonObj = JSON.parse( content );
          content = JSON.stringify( tmpJsonObj, null, '\t' );
        }
        catch (e)
        {

        }
      }

      aceEditor.getSession().setValue( content );
      aceEditor.getSession().setMode( mode );
      aceEditor.filePath = filePath;

      addAceContentChangedListener( aceEditor, tabId );
      addSaveCmdListener( aceEditor, tabId );

      this.showWindow( tabId, contentHref );
    }.bind(this)

    this.showWindow = function( tabId, contentHref )
    {
      var tabIdentifier = '#' + tabId + ' a[href=\"' + contentHref + '\"]';
      $( tabIdentifier).tab( 'show' );
    }.bind(this)

    this.checkWindowNeedsSaved = function( editorWindow )
    {
      var tabId = editorWindow.tabId;
      var path = editorWindow.editor.filePath;
      var contents = editorWindow.editor.getValue();
      var instance = this;

      var tabIdRef = '#' + tabId;
      var hasContentChangedClass = $( tabIdRef ).hasClass( __tabContentChangedClass );

      if ( hasContentChangedClass )
      {
        var initialisationProperties = {
          'title': "Confirm Save",
          'msg': "Save Changes to " + path + "?",
          'positiveButtonText': "Yes",
          'negativeButtonText': "No",
          'positiveCallback': function() { checkWindowNeedsSavedCallback( true, tabId, path, contents, instance ); },
          'negativeCallback': function() { checkWindowNeedsSavedCallback( false, tabId, path, contents, instance ); }
        };

        showModal ( $( "#modalConfirmYesNo" ), initialisationProperties );
      }
      else
      {
        this.closeWindow ( tabId );
      }
    }.bind(this)

    this.checkForUnsavedChanges = function ( dialogMessage )
    {
      var instance = this;
      var responseDeferred = $.Deferred();
      var unsavedChanges = false;

      $( this.editorWindows ).each( function ( index, obj )
      {
        var tabIdRef = '#' + obj.tabId;
        var hasContentChangedClass = $( tabIdRef ).hasClass( __tabContentChangedClass );

        if ( hasContentChangedClass )
        {
          unsavedChanges = true;
        }
      });

      if ( unsavedChanges )
      {
        var initialisationProperties = {
          'title': "Discard Unsaved Changes?",
          'msg': dialogMessage,
          'positiveButtonText': "Yes",
          'negativeButtonText': "No",
          'positiveCallback': function() { return responseDeferred.resolve(); },
          'negativeCallback': function() { return responseDeferred.reject(); }
        };

        showModal ($( "#modalConfirmYesNo" ), initialisationProperties );

        return responseDeferred.promise();
      }
      return false;
    }.bind(this)

    function checkWindowNeedsSavedCallback ( save, tabId, path, contents, instance )
    {
      if ( save )
      {
        var savePromise = doTabSave( tabId, path, contents );

        savePromise.then( function( response )
        {
          __jitResponses.addJITSuccess( response.message );
          instance.closeWindow ( tabId );
        },
        function ( response )
        {
          var msg = "An error occurred saving file [" + path + "]. " + response.message;
          console.log(msg);
          console.log(response.message);
          __jitResponses.addJITError( msg );
        });
      }
      else
      {
        instance.closeWindow ( tabId );
      }
    }

    this.closeWindow = function( tabId )
    {
        var instance = this;

        $( this.editorWindows ).each( function( index, obj )
        {
          if ( tabId === obj.tabId )
          {
            instance.editorWindows.splice( index, 1 );
            instance.update();
            return false;
          }
        });

        if ( this.editorWindows.length > 0 )
        {
          var editorWindow = this.editorWindows[0];
          var tabId = editorWindow.tabId;
          var contentHref = editorWindow.contentHref;

          this.showWindow( tabId, contentHref );
        }
    }.bind(this)

    this.closeAllWindows = function()
    {
      var instance = this;
      this.editorWindows.splice(0,this.editorWindows.length);
      instance.update();
    }.bind(this)

});

riot.tag2('file-explorer', '<div id="fileContextMenu" class="dropdown clearfix context-menu"><ul class="dropdown-menu context-menu" role="menu"><li><a id="contextMenuOpenFile" tabindex="-1" href="#" data-localize="labels.open">Open</a></li><li><a id="contextMenuSaveFile" tabindex="-1" href="#" data-localize="labels.save">Save</a></li><li><a id="contextMenuSaveFileAs" tabindex="-1" href="#" data-localize="labels.saveAs">Save As...</a></li><li><a id="contextMenuRenameFile" tabindex="-1" href="#" data-localize="labels.rename">Rename</a></li><li><a id="contextMenuDeleteFile" tabindex="-1" href="#" data-localize="labels.delete">Delete</a></li></ul></div><div id="folderContextMenu" class="dropdown clearfix context-menu"><ul class="dropdown-menu context-menu" role="menu"><li class="dropdown-submenu"><a class="no-click" tabindex="-1" href="#" data-localize="labels.new">New..</a><ul class="dropdown-menu"><li><a id="contextMenuNewFile" tabindex="-1" href="#" data-localize="labels.file">File</a></li><li><a id="contextMenuNewFolder" tabindex="-1" href="#" data-localize="labels.folder">Folder</a></li></ul></li><li><a id="contextMenuRenameFolder" tabindex="-1" href="#" data-localize="labels.rename">Rename</a></li><li><a id="contextMenuDeleteFolder" tabindex="-1" href="#" data-localize="labels.delete">Delete</a></li></ul></div><div id="fileTree"></div>', '', '', function(opts) {

  this.fileEditor = this.parent.fileEditor;
  this.newFileForm = this.parent.newFileForm;
  this.newFolderForm = this.parent.newFolderForm;
  this.saveAsForm = this.parent.saveAsForm;

  this.getFilesSuccess = function( response )
  {
    var node = this.createJSTreeNode( response.payload );
    node.state = { opened : true };

    return node;
  }.bind(this)

  this.getFileContentsSuccess = function( response )
  {
    var responseObj = response.payload;
    var fileContents = responseObj.contents;

    return fileContents;
  }.bind(this)

  this.createJSTreeNode = function(directory)
  {
      var instance = this;

      var node = {};
      node.id = directory.path;
      node.text = directory.name;
      node.data = { 'file_type' : directory.file_type };

      node.children = []
      var contents = directory.contents;
      $( contents ).each( function( index, item )
      {
        if ( item.file_type === 'folder' || item.file_type === 'py_package' )
        {
          node.children.push( instance.createJSTreeNode( item ) );
        }
        else
        {
          node.children.push( instance.createSingleJSTreeNode( item ) );
        }
      });

      return node;
  }.bind(this)

  this.createSingleJSTreeNode = function( item )
  {
    var node = {};

    node.id = item.path;
    node.text = item.name;

    var fileType = item.file_type;

    if ( fileType != 'folder' && fileType != 'py_package' )
    {
      node.icon = 'jstree-file';
    }
    else
    {
      node.children = [];
    }

    node.data = { 'file_type' : fileType };

    return node;
  }.bind(this)

  var instance = this;
  var getFilesDeferred = getFiles( '/app' );

  getFilesDeferred.then( function( response )
  {
    if ( response.success )
    {
      var node = instance.getFilesSuccess( response );
      nodeList = [node];

      $( '#fileTree' ).jstree(
      {
        'core' : {
            'data' : nodeList,
            'multiple' : false,
            'themes' : {
              'variant' : 'large'
            },
            'check_callback' : true
          }
      });

      $( '#fileTree' ).bind( "dblclick.jstree", function ( event )
      {
        var liNode = $( event.target ).closest( 'li' )[0];

        var node = $( '#fileTree' ).jstree( true ).get_json( liNode.id );
        var fileType = node.data.file_type;

        if ( fileType != 'folder' && fileType != 'py_package' )
        {
          instance.handleOpenFile( node );
        }
      });
    }
    else {
      var msg = "An error occurred retrieving list of application files."
      console.log(msg);
      console.log(response.message);
      __jitResponses.addJITError( msg );
    }
  });

  $( function ()
  {
    $( '#fileTree' ).bind( "click.jstree", function ( event )
    {
      var liNode = $( event.target ).closest( 'li' )[0];
      var node = $( '#fileTree' ).jstree( true ).get_json( liNode.id );
      var fileType = node.data.file_type;

      if ( fileType === 'folder' || fileType === 'py_package' )
      {
        var isFileFormOpened = instance.newFileForm.isOpened;
        var isFolderFormOpened = instance.newFolderForm.isOpened;
        var isSaveAsFormOpened = instance.saveAsForm.isOpened;

        if ( isFileFormOpened )
        {
            instance.newFileForm.setFolderSelected( node.id );
        }
        else if ( isFolderFormOpened )
        {
          instance.newFolderForm.setFolderSelected( node.id );
        }
        else if ( isSaveAsFormOpened )
        {
          instance.saveAsForm.setFolderSelected ( node.id );
        }
      }
    });
  });

  this.handleOpenFile = function( node )
  {
    var filePath = node.id;
    var tabId = instance.fileEditor.getTabId( filePath );

    if ( ! instance.fileEditor.hasWindow( tabId ) )
    {
      var contentsPromise = getFileContents( filePath );

      contentsPromise.then( function ( response )
      {
        if ( response.success )
        {
          var contents = instance.getFileContentsSuccess( response );
          instance.fileEditor.addEditorWindow( node, contents );
        }
        else {
          var msg = "An error occurred retrieving contents of file [" + filePath + "].";
          console.log(msg);
          console.log(response.message);
          __jitResponses.addJITError( msg );
        }
      });
    }
    else
    {
      var contentHref = '#' + instance.fileEditor.getFilePathId( filePath );
      instance.fileEditor.showWindow( tabId, contentHref );
    }
  }.bind(this)

  this.updateNodes = function( newPath, node )
  {
    var oldPath = node.id;
    var fileType = node.data.file_type;

    $( '#fileTree' ).jstree( 'set_id', node, newPath );

    if ( fileType === 'folder' || fileType === 'py_package' )
    {
      $( node.children ).each( function( index, obj )
      {
        var childNode = $( '#fileTree' ).jstree( true ).get_json( obj );
        var newChildPath = newPath + '/' + childNode.text;
        instance.updateNodes( newChildPath, childNode );
      });
    }
    else
    {
      var fileTypeIndex = newPath.lastIndexOf( '.' );
      var fileType = ( fileTypeIndex != -1 ) ? newPath.substring( fileTypeIndex, newPath.length ) : "file";
      node.data.file_type = fileType;

      var editorWindow = instance.fileEditor.getEditorWindowByFilePath( oldPath );

      if ( editorWindow )
      {
        instance.fileEditor.pushNodeUpdate( node, editorWindow );
      }
    }
  }.bind(this)

  this.handleSaveNode = function ( path )
  {
    var filePath = path;
    var tabId = instance.fileEditor.getTabId( filePath );
    var editorWindow = instance.fileEditor.getEditorWindowByFilePath ( filePath )
    var contents = editorWindow.editor.getValue();

    var savePromise = doTabSave( tabId, filePath, contents );

    savePromise.then( function( response )
    {
      __jitResponses.addJITSuccess( response.message )
    },
    function ( response )
    {
      var msg = "An error occurred saving file [" + path + "]. " + response.message;
      console.log(msg);
      console.log(response.message);
      __jitResponses.addJITError( msg );
    });
  }.bind(this)

  this.handleSaveAsNode = function ( path )
  {
    this.parent.resetForms();
    this.saveAsForm.openForm( path );
  }.bind(this)

  this.saveAsCallback = function( oldNodePath, fileObj )
  {
    var newNode = this.createSingleJSTreeNode( fileObj );
    var parentNodeId = fileObj.path.substring( 0, ( fileObj.path.length - ( fileObj.name.length + 1 ) ) );
    var parentNode = $( '#fileTree' ).jstree('get_node', '#' + parentNodeId );
    var position = 'last';
    var newNodeFilePath = fileObj.path;

    newNodeId = $( '#fileTree' ).jstree( 'create_node', parentNode, newNode, position );
    $('#fileTree').jstree("deselect_all", false);
    $('#fileTree').jstree("select_node", newNodeId, true);

    var newNodeObj = $( '#fileTree' ).jstree( true ).get_json( newNode );
    var editorWindow = instance.fileEditor.getEditorWindowByFilePath( oldNodePath );

    if ( editorWindow )
    {

      var tabId = instance.fileEditor.getTabId ( oldNodePath )
      var tabIdRef = '#' + tabId;
      var hasContentChangedClass = $( tabIdRef ).hasClass( __tabContentChangedClass );

      if ( hasContentChangedClass )
      {
        var contents = editorWindow.editor.getValue();

        $( tabIdRef ).removeClass( __tabContentChangedClass );
        $( tabIdRef ).addClass( __tabSavingClass );

        var contentsObj = { 'contents' : contents };
        var postContentsPromise = postFileContents( newNodeFilePath, contentsObj );

        postContentsPromise.then( function( response )
        {
          $( tabIdRef ).removeClass( __tabSavingClass );

          if ( response.success )
          {
            instance.fileEditor.pushNodeUpdate( newNodeObj, editorWindow );
          }
          else
          {
            $( tabIdRef ).addClass( __tabContentChangedClass );
            var msg = 'An error occurred transferring unsaved changes into the new file copy.'
            console.log(msg);
            console.log(response.message);
            __jitResponses.addJITError( msg );
          }
        });
      }
      else {
        instance.fileEditor.pushNodeUpdate( newNodeObj, editorWindow );
      }
    }
  }.bind(this)

  this.handleRenameNode = function( node )
  {
    var orgName = node.text;
    $( '#fileTree' ).jstree( true ).edit( node, orgName, function ( node )
    {
      var filePath = node.id;
      var newName = node.text;

      if ( newName === orgName )
      {
          return;
      }

      if (! /^[a-z0-9-_.]+$/i.test( newName ))
      {
        __jitResponses.addJITError("Error renaming file/folder. New name must only contain alphanumeric characters, underscores or hyphens");
        $( '#fileTree' ).jstree( "rename_node", node, orgName );
        return;
      }

      var renamePromise = renameFile( filePath, newName );

      renamePromise.then( function ( response )
      {
        if ( response.success )
        {

          var fileObj = response.payload;
          var newPath = fileObj.path;
          instance.updateNodes( newPath, node );
          __jitResponses.addJITSuccess( response.message );
        }
        else
        {
          var msg = "An error occurred renaming file [" + filePath + "]: " + response.message;
          console.log(msg);
          console.log(response.message);
          __jitResponses.addJITError( msg );
          $( '#fileTree' ).jstree( "rename_node", node, orgName );
        }
      });
    });
  }.bind(this)

  this.handleDeleteNode = function( node )
  {
    var fileType = node.data.file_type;
    var confirmMsg = 'Are you sure you want to delete ' + node.text + '?'

    if (fileType === 'folder')
    {
      var children = node.children.length

      if (children > 0)
      {
        confirmMsg = 'Are you sure you want to delete unempty folder ' + node.text
         + '?\nThis will also remove its contents.'
      }
    }

    var initialisationProperties = {
      'title': "Confirm Deletion",
      'msg': confirmMsg,
      'positiveButtonText': "Yes",
      'negativeButtonText': "No",
      'positiveCallback': function() { deleteCallback( node ); },
    };

    showModal ( $( "#modalConfirmYesNo" ), initialisationProperties );
  }.bind(this)

  function deleteCallback( node )
  {
    var path = node.id;
    var deletePromise = deleteFile( path );

    deletePromise.then( function( response )
    {
      if ( response.success )
      {

        var tabId = instance.fileEditor.getTabId( node.id );
        instance.fileEditor.closeWindow( tabId );

        $( node.children ).each( function( index, obj )
        {
          var childNode = $( '#fileTree' ).jstree( true ).get_json( obj );
          var tabId = instance.fileEditor.getTabId( childNode.id );
          instance.fileEditor.closeWindow( tabId );
        });

        $( '#fileTree' ).jstree( 'delete_node', node );
        __jitResponses.addJITSuccess( response.message );
      }
      else
      {
        var msg = "An error occurred deleting file [" + path + "]."
        console.log(msg);
        console.log(response.message);
        __jitResponses.addJITError( msg );
      }
    });
}

  this.handleNewFile = function( path )
  {
    instance.fileEditor.getEditorWindowByActiveTab();
    this.parent.resetForms();
    var targetDirectory = path;
    this.newFileForm.openForm( targetDirectory );
  }.bind(this)

  this.newFileCallback = function( fileObj )
  {
    var newNode = this.createSingleJSTreeNode( fileObj );
    var parentNodeId = fileObj.path.substring( 0, ( fileObj.path.length - ( fileObj.name.length + 1 ) ) );
    var parentNode = $( '#fileTree' ).jstree('get_node', '#' + parentNodeId );
    var position = 'last';

    $( '#fileTree' ).jstree( 'create_node', parentNode, newNode, position );
  }.bind(this)

  this.handleNewFolder = function( path )
  {
    this.parent.resetForms();
    var targetDirectory = path;
    this.newFolderForm.openForm( targetDirectory );
  }.bind(this)

  this.newFolderCallback = function( folderObj )
  {
    var newNode = this.createSingleJSTreeNode( folderObj );

    var parentNodeId = folderObj.path.substring( 0, ( folderObj.path.length - ( folderObj.name.length +1 ) ) );
    var parentNode = $( '#fileTree' ).jstree('get_node', '#' + parentNodeId );
    var position = 'last';

    $( '#fileTree').jstree( 'create_node', parentNode, newNode, position );
  }.bind(this)

  $( function () {

    var $fileContextMenu = $( "#fileContextMenu" );
    var $folderContextMenu = $( "#folderContextMenu" );

    var hideContexts = function ()
    {
      $fileContextMenu.hide();
      $folderContextMenu.hide();

      removeDisabled( $fileContextMenu );
      removeDisabled( $folderContextMenu );
    }

    $( document ).on( 'contextmenu', '.jstree-anchor', function ( e ){

      hideContexts();

      $( '#fileTree' ).jstree( 'activate_node', e.target );
      $nodeClicked = $( '#fileTree' ).jstree( true ).get_node( e.target );

      var filePath = $nodeClicked.id;
      var fileType = $nodeClicked.data.file_type;

      var $target;

      if ( fileType === 'folder' || fileType === 'py_package' )
      {
        $target = $folderContextMenu;
        disableFolderActions( $nodeClicked );
      }
      else
      {
        $target = $fileContextMenu;
        disableFileActions( $nodeClicked );
      }

      toggleSaveOption ( filePath );

      var elm = $(this);

      var outerWidth = elm.outerWidth();
      var xPos = elm.position().left + outerWidth + 10;
      var yPos = elm.position().top;

      $target.css({
        display : "block",
        left : xPos,
        top : yPos
      });

      return false;
    });

    $fileContextMenu.on( 'click', 'a', function ( e )
    {
      var id = $( this )[0].id;
      invokeTargetContextOption( id, $nodeClicked );
      $fileContextMenu.hide();
      removeDisabled( $fileContextMenu );
    });

    $folderContextMenu.on( 'click', 'a', function ( e )
    {
      if ( $( e.target ).hasClass( 'no-click' ) )
      {
        return false;
      }

      var id = $( this )[0].id;
      invokeTargetContextOption( id, $nodeClicked );
      $folderContextMenu.hide();
      removeDisabled( $folderContextMenu );
    });

    $( document ).click( function ( e )
    {
      var button = e.which || e.button;
      if ( button === 1 )
      {
        hideContexts();
      }
    });

    function invokeTargetContextOption( contentId, node )
    {
      switch ( contentId )
      {

        case "contextMenuOpenFile":
          instance.handleOpenFile( node );
          break;
        case "contextMenuSaveFile":
          instance.handleSaveNode ( node.id );
          break;
        case "contextMenuSaveFileAs":
          instance.handleSaveAsNode ( node.id );
          break;
        case "contextMenuRenameFile":
          instance.handleRenameNode( node );
          break;
        case "contextMenuDeleteFile":
          instance.handleDeleteNode( node );
          break;

        case "contextMenuNewFile":
          instance.handleNewFile( node.id );
          break;
        case "contextMenuNewFolder":
          instance.handleNewFolder( node.id );
          break;
        case "contextMenuRenameFolder":
          instance.handleRenameNode( node )
          break;
        case "contextMenuDeleteFolder":
          instance.handleDeleteNode( node );
          break;

      }
    }

    function disableFolderActions( node )
    {
      var filePath = node.id;

      if ( filePath === '/app' || filePath === '/app/qpylib' )
      {

        var renameFolderId = "#" + "contextMenuRenameFolder";
        var deleteFolderId = "#" + "contextMenuDeleteFolder";

        $( renameFolderId ).addClass( "disabled" );
        $( deleteFolderId ).addClass( "disabled" );
      }
    }

    function disableFileActions( node )
    {
      var filePath = node.id;
      var tabId = instance.fileEditor.getTabId( filePath );

      if ( filePath === '/app/manifest.json'
            || filePath === '/app/views.py'
            || filePath === '/app/__init__.py'
            || filePath.match( '^/app/qpylib/' ) )
      {
        var renameFileId = "#" + "contextMenuRenameFile";
        var deleteFileId = "#" + "contextMenuDeleteFile";

        $( renameFileId ).addClass( "disabled" );
        $( deleteFileId ).addClass( "disabled" );
      }

      if ( instance.fileEditor.hasWindow( tabId ) )
      {
        var openFileId = "#" + "contextMenuOpenFile";
        $( openFileId ).addClass( "disabled" );
      }
    }

    function removeDisabled( contextMenu )
    {
      $( contextMenu.find( 'a' ) ).each( function ( index, obj )
      {
        var idRef = '#' + obj.id;

        if ( $( idRef ).hasClass( 'disabled' ) )
        {
          $( idRef ).removeClass( 'disabled' )
        }
      });
    }
  });

  function toggleSaveOption ( nodeFilePath )
  {
    var editorWindow = instance.fileEditor.getEditorWindowByFilePath ( nodeFilePath )
    if ( editorWindow )
    {
      var tabId = instance.fileEditor.getTabId ( nodeFilePath )
      var tabIdRef = '#' + tabId;
      var hasContentChangedClass = $( tabIdRef ).hasClass( __tabContentChangedClass );

      if ( hasContentChangedClass )
      {
        $( "#contextMenuSaveFile" ).removeClass( "disabled" );
        return
      }
    }
    $( "#contextMenuSaveFile" ).addClass( "disabled" );
  }

});

riot.tag2('new-file-form', '<div class="app-form-div" id="newFileFormWrapper"><div class="app-form-header"><p data-localize="forms.newFile.title">New File</p></div><form class="app-form" id="newFileForm"><div class="form-element" id="parentFolderElement"><label class="form-label" for="fileParentFolderInput" data-localize="forms.newFile.parentFolderSelect">Enter or select (via the filetree) the full path to the parent folder:</label><input class="form-input-box" type="text" id="fileParentFolderInput" required></input><span id="errorInvalidFolder" class="form-element-error" data-localize="errors.folderRequired">This value is required and must be an existing folder.</span></div><div class="form-element" id="fileNameElement"><label class="form-label" for="fileNameInput" data-localize="forms.newFile.fileName">New file name:</label><input class="form-input-box" type="text" id="fileNameInput" required></input><span id="errorValueRequired" class="form-element-error" data-localize="errors.nameInvalid">This value is required and must not be an existing file or folder in the current directory.</span><span id="errorInvalidChars" class="form-element-error" data-localize="errors.invalidChars">Names must only contain alphanumeric, underscore or hyphen characters.</span></div></form><div class="form-submit-control" align="right"><button type="button" class="app-btn cancel-btn" onclick="{resetForm}" id="newFileCancelBtn" data-localize="buttons.cancel">Cancel</button><button type="button" class="app-btn primary-btn" onclick="{submitForm}" data-localize="buttons.confirm" id="newFileConfirmBtn">Confirm</button></div></div>', '', '', function(opts) {

    this.isOpened = false;
    this.fileExplorer = this.parent.fileExplorer;
    var instance = this;

    this.openForm = function( targetDirectory )
    {
      this.setFolderSelected( targetDirectory )
      var $fileNameInput = $( '#fileNameInput' )
      $fileNameInput.val( null );
      $fileNameInput.focus();
      this.isOpened = true;
      this.parent.openFormWrapper( '#fileFormWrapper' );
    }.bind(this)

    this.setFolderSelected = function( folder )
    {
      $( '#fileParentFolderInput' ).val( folder );
    }.bind(this)

    this.resetForm = function()
    {
      this.setFolderSelected( '' );
      this.toggleErrorStatus( true, "#parentFolderElement .form-element-error" );
      this.toggleErrorStatus( true, "#fileNameElement .form-element-error" );

      this.isOpened = false;
      this.parent.closeFormWrapper( '#fileFormWrapper' );
    }.bind(this)

    this.submitForm = function()
    {
      var folder = $( '#fileParentFolderInput' ).val();

      if ( folder.substr( folder.length - 1) == '/' )
      {
        folder = folder.substr( 0, folder.length -2 );
      }

      var fileName = $( '#fileNameInput' ).val();

      var isValid = this.validate( folder, fileName );

      if ( ! isValid )
      {
        return false;
      }

      var filePath = folder + '/' + fileName;
      var createFilePromise = createFile( filePath, false );

      createFilePromise.then( function ( response )
      {
        if ( response.success )
        {
          var newFileObj = response.payload;
          instance.resetForm();
          instance.fileExplorer.newFileCallback( newFileObj );
          __jitResponses.addJITSuccess( response.message );
        }
        else
        {
          var msg = "An error occurred creating the new file [" + filePath + "]."
          console.log(msg);
          console.log(response.message);
          __jitResponses.addJITError( msg );
          instance.resetForm();
        }
      });
    }.bind(this)

    this.validate = function( parentFolder, fileName )
    {
        var parentFolderResult = this.validateParentFolder( parentFolder );
        this.toggleErrorStatus( parentFolderResult, "#parentFolderElement #errorInvalidFolder" );

        var fileNameResult = this.validateFileName( parentFolder, fileName );

        for ( var error in fileNameResult.errorDetails )
        {
          this.toggleErrorStatus( fileNameResult.errorDetails[error], "#fileNameElement #" + error );
        }
        return ( parentFolderResult && fileNameResult.allValid );
    }.bind(this)

    this.toggleErrorStatus = function( isValid, elementId )
    {
      if ( isValid )
      {
        $( elementId ).removeClass( "invalid" ).addClass( "valid" );
      }
      else
      {
        $( elementId ).removeClass( "valid" ).addClass( "invalid" );
      }
    }.bind(this)

    this.validateParentFolder = function( parentFolder )
    {
      var node = $( '#fileTree' ).jstree( true ).get_node( parentFolder );

      if ( ! node )
      {
        return false;
      }

      var fileType = node.data.file_type;

      if ( fileType != 'folder' && fileType != 'py_package' )
      {
        return false;
      }

      return true;
    }.bind(this)

    this.validateFileName = function( parentFolder, fileName )
    {
      var errorsValid = {
        errorValueRequired: true,
        errorInvalidChars: true
      };

      if ( ! fileName )
      {
        errorsValid.errorValueRequired = false;
      }

      var filePath = parentFolder + '/' + fileName;
      var node = $( '#fileTree' ).jstree( true ).get_node( filePath );

      if ( node )
      {
        errorsValid.errorValueRequired = false;
      }

      if (! /^[a-z0-9-_.]+$/i.test( fileName ))
      {
        errorsValid.errorInvalidChars = false;
      }

      return { allValid : errorsValid.errorValueRequired
        && errorsValid.errorInvalidChars, errorDetails : errorsValid }
    }.bind(this)

});

riot.tag2('new-folder-form', '<div class="app-form-div" id="newFolderFormWrapper"><div class="app-form-header"><p data-localize="forms.newFolder.title">New Folder</p></div><form class="app-form" id="newFolderForm"><div class="form-element" id="folderParentFolderElement"><label class="form-label" for="folderParentFolderInput" data-localize="forms.newFile.parentFolderSelect">Enter or select (via the filetree) the full path to the parent folder:</label><input class="form-input-box" type="text" id="folderParentFolderInput" required></input><span id="errorInvalidFolder" class="form-element-error" data-localize="errors.folderRequired">This value is required and must be an existing folder.</span></div><div class="form-element" id="folderNameElement"><label class="form-label" for="folderNameInput" data-localize="forms.newFolder.folderName">New folder name:</label><input class="form-input-box" type="text" id="folderNameInput" required></input><span id="errorValueRequired" class="form-element-error" data-localize="errors.nameInvalid">This value is required and must not be an existing file or folder in the current directory.</span><span id="errorInvalidChars" class="form-element-error" data-localize="errors.invalidChars">Names must only contain alphanumeric, underscore or hyphen characters</span></div></form><div class="form-submit-control" align="right"><button type="button" class="app-btn cancel-btn" onclick="{resetForm}" id="newFolderCancelBtn" data-localize="buttons.cancel">Cancel</button><button type="button" class="app-btn primary-btn" onclick="{submitForm}" data-localize="buttons.confirm" id="newFolderConfirmBtn">Confirm</button></div></div>', '', '', function(opts) {
    this.isOpened = false;
    this.fileExplorer = this.parent.fileExplorer;
    var instance = this;

    this.openForm = function( targetDirectory )
    {
      this.setFolderSelected( targetDirectory )
      var $folderNameInput = $( '#folderNameInput' )
      $folderNameInput.val( null );
      $folderNameInput.focus();
      this.isOpened = true;
      this.parent.openFormWrapper( '#folderFormWrapper' );
    }.bind(this)

    this.setFolderSelected = function( folder )
    {
      $( '#folderParentFolderInput' ).val( folder );
    }.bind(this)

    this.resetForm = function()
    {
      this.setFolderSelected( '' );
      this.toggleErrorStatus( true, "#folderParentFolderElement .form-element-error" );
      this.toggleErrorStatus( true, "#folderNameElement .form-element-error" );

      this.isOpened = false;
      this.parent.closeFormWrapper( '#folderFormWrapper' );
    }.bind(this)

    this.submitForm = function()
    {
      var folder = $( '#folderParentFolderInput' ).val();

      if ( folder.substr( folder.length - 1) == '/' )
      {
        folder = folder.substr( 0, folder.length -2 );
      }

      var folderName = $( '#folderNameInput' ).val();

      var isValid = this.validate( folder, folderName );

      if ( ! isValid )
      {
        return false;
      }

      var folderPath = folder + '/' + folderName;
      var createFolderPromise = createFile( folderPath, true );

      createFolderPromise.then( function ( response )
      {
        if ( response.success )
        {
          var newFolderObj = response.payload;
          instance.resetForm();
          instance.fileExplorer.newFolderCallback( newFolderObj );
          __jitResponses.addJITSuccess( response.message );
        }
        else
        {
          var msg = "An error occurred creating the new folder [" + folderPath + "]."
          console.log(msg);
          console.log(response.message);
          __jitResponses.addJITError( msg );
          instance.resetForm();
        }
      });
    }.bind(this)

    this.validate = function( parentFolder, folderName )
    {
        var parentFolderResult = this.validateParentFolder( parentFolder );
        this.toggleErrorStatus( parentFolderResult, "#folderParentFolderElement #errorInvalidFolder" );

        var folderNameResult = this.validateFolderName( parentFolder, folderName );

        for ( var error in folderNameResult.errorDetails )
        {
          this.toggleErrorStatus( folderNameResult.errorDetails[error], "#folderNameElement #" + error );
        }
        return ( parentFolderResult && folderNameResult.allValid );
    }.bind(this)

    this.toggleErrorStatus = function( isValid, elementId )
    {
      if ( isValid )
      {
        $( elementId ).removeClass( "invalid" ).addClass( "valid" );
      }
      else
      {
        $( elementId ).removeClass( "valid" ).addClass( "invalid" );
      }
    }.bind(this)

    this.validateParentFolder = function( parentFolder )
    {
      var node = $( '#fileTree' ).jstree( true ).get_node( parentFolder );

      if ( ! node )
      {
        return false;
      }

      var fileType = node.data.file_type;

      if ( fileType != 'folder' && fileType != 'py_package' )
      {
        return false;
      }

      return true;
    }.bind(this)

    this.validateFolderName = function( parentFolder, folderName )
    {
      var errorsValid = {
        errorValueRequired: true,
        errorInvalidChars: true
      };

      if ( ! folderName )
      {
        errorsValid.errorValueRequired = false;
      }

      var folderPath = parentFolder + '/' + folderName;
      var node = $( '#fileTree' ).jstree( true ).get_node( folderPath );

      if ( node )
      {
        errorsValid.errorValueRequired = false;
      }

      if (! /^[a-z0-9-_.]+$/i.test( folderName ))
      {
        errorsValid.errorInvalidChars = false;
      }
      return { allValid : errorsValid.errorValueRequired
        && errorsValid.errorInvalidChars, errorDetails : errorsValid }
    }.bind(this)

});

riot.tag2('save-as-form', '<div class="app-form-div" id="saveAsFormWrapper"><div class="app-form-header"><p data-localize="forms.saveAs.title">Save As</p></div><form class="app-form" id="saveAsForm"><div class="form-element" id="saveAsParentFolderElement"><label class="form-label" for="saveAsParentFolderInput" data-localize="forms.saveAs.parentFolderSelect">Enter or select (via the filetree) the full path to the parent folder:</label><input class="form-input-box" type="text" id="saveAsParentFolderInput" required></input><span id="errorInvalidFolder" class="form-element-error" data-localize="errors.folderRequired">This value is required and must be an existing folder.</span></div><div class="form-element" id="saveAsNameElement"><label class="form-label" for="saveAsNameInput" data-localize="forms.saveAs.fileName">File name:</label><input class="form-input-box" type="text" id="saveAsNameInput" required></input><span id="errorValueRequired" class="form-element-error" data-localize="errors.nameInvalid">This value is required and must not be an existing file or folder in the current directory.</span><span id="errorInvalidChars" class="form-element-error" data-localize="errors.invalidChars">Names must only contain alphanumeric, underscore or hyphen characters.</span></div></form><div class="form-submit-control" align="right"><button type="button" class="app-btn cancel-btn" onclick="{resetForm}" id="saveAsCancelBtn" data-localize="buttons.cancel">Cancel</button><button type="button" class="app-btn primary-btn" onclick="{submitForm}" data-localize="buttons.confirm" id="saveAsConfirmBtn">Confirm</button></div></div>', '', '', function(opts) {
    this.isOpened = false;
    this.fileExplorer = this.parent.fileExplorer;
    var instance = this;
    var oldNodePath;

    this.openForm = function( path )
    {
      var splitDir = path.split('/');
      currentFileName = splitDir.pop();
      targetDirectory = splitDir.join('/');
      this.setFolderSelected( targetDirectory );
      this.setCurrentFileName ( currentFileName );
      this.isOpened = true;
      oldNodePath = path;
      this.parent.openFormWrapper( '#saveAsFormWrapper' );
    }.bind(this)

    this.setFolderSelected = function( folder )
    {
      $( '#saveAsParentFolderInput' ).val( folder );
    }.bind(this)

    this.setCurrentFileName = function ( currentFileName )
    {
      $( '#saveAsNameInput' ).val( currentFileName );
    }.bind(this)

    this.resetForm = function()
    {
      this.setFolderSelected( '' );
      this.toggleErrorStatus( true, "#saveAsParentFolderElement .form-element-error" );
      this.toggleErrorStatus( true, "#saveAsNameElement .form-element-error" );

      this.isOpened = false;
      this.parent.closeFormWrapper( '#saveAsFormWrapper' );
    }.bind(this)

    this.submitForm = function()
    {
      var folder = $( '#saveAsParentFolderInput' ).val();

      if ( folder.substr( folder.length - 1) == '/' )
      {
        folder = folder.substr( 0, folder.length -2 );
      }

      var saveAsName = $( '#saveAsNameInput' ).val();

      var isValid = this.validate( folder, saveAsName );

      if ( ! isValid )
      {
        return false;
      }

      var folderPath = folder + '/' + saveAsName;
      var saveAsPromise = copyFile( oldNodePath, folderPath );

      saveAsPromise.then( function ( response )
      {
        if ( response.success )
        {
          var copiedFileObj = response.payload;
          instance.resetForm();
          instance.fileExplorer.saveAsCallback( oldNodePath, copiedFileObj );
          __jitResponses.addJITSuccess( response.message );
        }
        else
        {
          var msg = "An error occurred saving a new copy of file [" + oldNodePath + "]."
          console.log(msg);
          console.log(response.message);
          __jitResponses.addJITError( msg );
          instance.resetForm();
        }
      });
    }.bind(this)

    this.validate = function( parentFolder, saveAsName )
    {
        var parentFolderResult = this.validateParentFolder( parentFolder );
        this.toggleErrorStatus( parentFolderResult, "#saveAsParentFolderElement #errorInvalidFolder" );

        var saveAsNameResult = this.validatesaveAsName( parentFolder, saveAsName );

        for (var error in saveAsNameResult.errorDetails)
        {
          this.toggleErrorStatus( saveAsNameResult.errorDetails[error], "#saveAsNameElement #" + error );
        }
        return ( parentFolderResult && saveAsNameResult.allValid );
    }.bind(this)

    this.toggleErrorStatus = function( isValid, elementId )
    {
      if ( isValid )
      {
        $( elementId ).removeClass( "invalid" ).addClass( "valid" );
      }
      else
      {
        $( elementId ).removeClass( "valid" ).addClass( "invalid" );
      }
    }.bind(this)

    this.validateParentFolder = function( parentFolder )
    {
      var node = $( '#fileTree' ).jstree( true ).get_node( parentFolder );

      if ( ! node )
      {
        return false;
      }

      var fileType = node.data.file_type;

      if ( fileType != 'folder' && fileType != 'py_package' )
      {
        return false;
      }

      return true;
    }.bind(this)

    this.validatesaveAsName = function( parentFolder, saveAsName )
    {
      var errorsValid = {
        errorValueRequired: true,
        errorInvalidChars: true
      };

      if ( ! saveAsName )
      {
        errorsValid.errorValueRequired = false;
      }

      var filePath = parentFolder + '/' + saveAsName;
      var node = $( '#fileTree' ).jstree( true ).get_node( filePath );

      if ( node )
      {
        errorsValid.errorValueRequired = false;
      }

      if (! /^[a-z0-9-_.]+$/i.test( saveAsName ))
      {
        errorsValid.errorInvalidChars = false;
      }
      return { allValid : errorsValid.errorValueRequired
        && errorsValid.errorInvalidChars, errorDetails : errorsValid }
    }.bind(this)

});

riot.tag2('confirm-yes-no-dialog', '<div id="modalConfirmYesNo" class="modal custom fade" tabindex="-1" role="dialog"><div class="modal-dialog" role="document"><div class="modal-content"><div class="modal-header"><button type="button" class="close" aria-label="Close" onclick="{closeButtonClicked}"><span aria-hidden="true">&times;</span></button><h4 id="lblTitleConfirmYesNo" class="modal-title">Confirmation</h4></div><div class="modal-body"><p id="lblMsgConfirmYesNo"></p></div><div class="modal-footer"><button id="btnNoConfirmYesNo" type="button" class="btn btn-default">Cancel</button><button id="btnYesConfirmYesNo" type="button" class="btn btn-primary">Confirm</button></div></div></div></div>', '', '', function(opts) {
    this.closeButtonClicked = function()
    {
      hideModal ( $("#modalConfirmYesNo" ) );
    }.bind(this)
});

riot.tag2('confirm-dialog', '<div id="modalConfirm" class="modal custom fade" tabindex="-1" role="dialog"><div class="modal-dialog" role="document"><div class="modal-content"><div class="modal-header"><button type="button" class="close" aria-label="Close" onclick="{closeButtonClicked}"><span aria-hidden="true">&times;</span></button><h4 id="lblTitleConfirm" class="modal-title">Confirmation</h4></div><div class="modal-body"><p id="lblMsgConfirm"></p></div><div class="modal-footer"><button id="btnConfirm" type="button" class="btn btn-primary" data-dismiss="modal">Confirm</button></div></div></div></div>', '', '', function(opts) {
    this.closeButtonClicked = function()
    {
      hideModal ( $("#modalConfirm" ) );
    }.bind(this)
});
