riot.tag2('jit-responses', '<div class="jitContainer"><div each="{successJIT, s in successJITs}" class="alert alert-success fade" id="{successJIT.id}"><span class="successAlertMessage">{successJIT.message}</span><button type="button" class="close" aria-label="Close" onclick="{successAlertClicked}"><span aria-hidden="true">×</span></button></div><div each="{errorJIT, e in errorJITs}" class="alert alert-danger fade" id="{errorJIT.id}"><span class="errorAlert">{errorJIT.message}</span><button type="button" class="close" aria-label="Close" onclick="{errorAlertClicked}"><span aria-hidden="true">×</span></button></div>', '', '', function(opts) {

    this.tmpId = 0;
    this.successJITs = [];
    this.errorJITs = [];

    this.getMessageId = function()
    {
      return this.tmpId++
    }.bind(this)

    this.addJITSuccess = function( message )
    {
      var jitSuccessObj = {
        id : this.getMessageId(),
        message : message
      }

      this.successJITs.push( jitSuccessObj );
      this.update();

      var jitId = "#" + jitSuccessObj.id;
      $( jitId ).addClass( "in" );

      this.createSuccessFade( jitSuccessObj.id );
    }.bind(this)

    this.addJITError = function( message )
    {
      var jitErrorObj = {
        id : this.getMessageId(),
        message : message
      }

      this.errorJITs.push( jitErrorObj );
      this.update();

      var id = "#" + jitErrorObj.id;
      var instance = this;

      $( id ).addClass( "in" );
    }.bind(this)

    this.parseId = function( event )
    {
      var id = -1;
      var target = event.target;

      if ( target.nodeName === "BUTTON" )
      {
        id = target.parentNode.id;
      }
      else if ( target.nodeName === "SPAN" )
      {
        id = target.parentNode.parentNode.id;
      }
      return id;
    }.bind(this)

    this.successAlertClicked = function( e )
    {
      var id = this.parseId( e );

      if ( id === -1 )
      {
        console.error("appId parsed was -1");
        return;
      }
      var jitId = "#" + id;
      this.removeSuccessJIT( id );
    }.bind(this)

    this.errorAlertClicked = function ( e )
    {
      var id = this.parseId ( e );

      if ( id === -1 )
      {
        console.error("appId parsed was -1");
        return;
      }
      var jitId = '#' + id;
      this.removeErrorJIT( id );
    }.bind(this)

    this.removeSuccessJIT = function( id )
    {
      for( i=this.successJITs.length-1; i>=0; i--)
      {
        if( this.successJITs[i].id == id ) this.successJITs.splice(i,1);
      }
      this.update();
    }.bind(this)

    this.removeErrorJIT = function( id )
    {
      for( i=this.errorJITs.length-1; i>=0; i--)
      {
        if( this.errorJITs[i].id == id ) this.errorJITs.splice(i,1);
      }
      this.update();
    }.bind(this)

    this.createSuccessFade = function( id )
    {
        var jqueryId = "#" + id;
        var instance = this;

        $( jqueryId ).delay( 4000 ).queue( function ()
        {
          $( jqueryId ).fadeOut( "slow", function ()
          {
            instance.removeSuccessJIT( id );
            instance.update();
          });

          $( this ).dequeue();
        });
    }.bind(this)

});
